package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.GP_PricingPuntoVentaDAO;
import com.rjconsultores.ventaboletos.entidad.GP_Pricing;
import com.rjconsultores.ventaboletos.entidad.GP_PricingPuntoVenta;
import com.rjconsultores.ventaboletos.entidad.PuntoVenta;
import com.rjconsultores.ventaboletos.service.GP_PricingPuntoVentaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("p_pricingPuntoVentaService")
public class GP_PricingPuntoVentaServiceImpl implements GP_PricingPuntoVentaService {

	@Autowired
	private GP_PricingPuntoVentaDAO pricingPuntoVentaDAO;

	public List<GP_PricingPuntoVenta> obtenerTodos() {
		return pricingPuntoVentaDAO.obtenerTodos();
	}

	public GP_PricingPuntoVenta obtenerID(Integer id) {
		return pricingPuntoVentaDAO.obtenerID(id);
	}

	@Transactional
	public GP_PricingPuntoVenta suscribir(GP_PricingPuntoVenta entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(GP_Pricing.ATIVO);

		return pricingPuntoVentaDAO.suscribir(entidad);
	}

	@Transactional
	public GP_PricingPuntoVenta actualizacion(GP_PricingPuntoVenta entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(GP_Pricing.ATIVO);

		return pricingPuntoVentaDAO.actualizacion(entidad);
	}

	@Transactional
	public void borrar(GP_PricingPuntoVenta entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(GP_Pricing.EXCLUIDO);

		pricingPuntoVentaDAO.actualizacion(entidad);
	}

	public Boolean obtenerPricingPuntoVenta(GP_Pricing pricing, PuntoVenta puntoVenta) {
		return pricingPuntoVentaDAO.obtenerPricingPuntoVenta(pricing, puntoVenta);
	}

	@Override
	public List<GP_PricingPuntoVenta> obtenerTodoPorPricing(GP_Pricing pricing) {
		return pricingPuntoVentaDAO.obtenerTodoPorPricing(pricing);
	}
}
